$(function () {
  module('Function');

  test('bind', function () {
    ok(function () {
      return this.length;
    }.bind([1, 2, 3])() === 3, 'Simple binding works.');

    ok(function (a) {
      return this.length + a;
    }.bind([1, 2, 3], [1])() === 4, 'An arguments array is passed');
  });

  test('curry', function () {
    ok(function (a, b) {
      return a + b;
    }.curry(1)(2) === 3, 'An argument list is bound.');
  });

  test('delay', function () {
    stop();
    var now = new Date();
    (function () {
      var delta = new Date() - now;
      start();
      // We need to be really hazy here because QUnit's stop/start
      // seems to widen the range of values here. Outside of QUnit
      // the range should be 1000-1010.
      ok(delta > 900 && delta < 1100, 'An acceptable delay is taken.');
    }).delay(1000);
  });

  test('empty', function () {
    ok(undefined === Function.empty()());
  });

  test('test', function () {
    ok(!Function.test(1), 'A number is not a function.');
    ok(!Function.test('[object Function]'), 'A string is not a function.');
    ok(!Function.test(/a/), 'A RegExp is not a function.');
    ok(!Function.test(new Date()), 'A Date is not a function.');
    ok(!Function.test({}), 'An object is not a function.');
    ok(Function.test(function () {}), 'A function literal is a function.');
    ok(Function.test(Function ()), 'A Function instance is a function.');
  });
});
